/*
    lattice, defined in DEF-text-files
*/
#include "daten.h"	/* define N=num_spins,Nw=num_bonds <= daten.def */
#define MODELFILE  "daten.def"

#define FF           fprintf(stderr," Error " __FILE__ " L%d: ",__LINE__)      
#define F0(x1)       {FF;fprintf(stderr,x1"\n");      exit(1);}
#define F1(x1,x2)    {FF;fprintf(stderr,x1"\n",x2);   exit(1);}
#define F2(x1,x2,x3) {FF;fprintf(stderr,x1"\n",x2,x3);exit(1);}

/* maximum number of different bounds */
#define DimJJ  8

double ini_pos[N][3];	/* positions of spins (Mar99, old: int) */
int ini_iw[Nw][2],	/* bounds */
    ini_wj[Nw],		/* Js */
    ini_wa[Nw],		/* Js attribut, 0=default, 1=PBC */
    ini_pe[N],          /* p_e used for sublattice definition */
    ini_sl[N],		/* sublattice index */
    ini_nw=0,		/* number of bounds */
    ini_nsl=0;		/* number of sublattices */
int ww_ini(){
    int i,j,k,nn,nw,jj[DimJJ];
    FILE *f1;char s1[1024];
    i=j=k=nn=nw=0;
    for(i=0;i<DimJJ;i++) jj[i]=0;
    f1=fopen(MODELFILE,"rt");
    if(!f1)F0("could not open file " MODELFILE);
    if(vvv)fprintf(stderr," read %s",MODELFILE);
    do { if(!fgets(s1,1023,f1))F0("read"); } while(*s1=='#');
    sscanf(s1,"%d%d%d",&nn,&nw,&k);if(N!=nn || nw>Nw){ 
      fprintf(stderr," N=%d=%d Nw=%d Nv=%d s1=%s",N,nn,nw,k,s1);
      F0("wrong definitions of N Nw Nv");}
    ini_nw=nw;
    for(i=0;i<N;i++){
      do { if(!fgets(s1,1023,f1))F0("read"); } while(*s1=='#');
      sscanf(s1,"%d%lf%lf%lf%d%*d",&j,
		&ini_pos[i][0],		/* x,y,z-pos */
		&ini_pos[i][1],
                &ini_pos[i][2], &ini_pe[i]);

      /* test for new sublattice index */
      for(j=0;j<i;j++) if( ini_pe[i]==ini_pe[j] ) break;
      if( j==i ){ ini_sl[i]=ini_nsl; ini_nsl++; }
      else      { ini_sl[i]=ini_sl[j];          }

    }
    for(i=0;i<nw;i++){ 
      do { if(!fgets(s1,1023,f1))F0("read"); } while(*s1=='#');
      sscanf(s1,"%u%d%d%*d%d%d",&j,&ini_iw[i][0],
                                   &ini_iw[i][1],
                                   &ini_wj[i], &k);
      ini_wa[i]=0;
      /* we dont want to draw PBC-bounds, getting a nicer picture */
      /* ToDo: set wa=1 if wj has a "+"-sign as PBC-flag */
      if(j>=nw)       F2(" s=%d out of range 0..%d",j,nw-1);
      if(i!=j )       F1(" idx!=%d",j);
      if( ini_wj[i]>=DimJJ ) F0("to much different bounds, enlarge DimJJ!?");
      jj[ini_wj[i]]++;
    }
    fclose(f1);
    if(vvv){
      fprintf(stderr," bonds:");
      for(i=0;i<DimJJ;i++)if(jj[i]) fprintf(stderr," %d J%d",jj[i],i);
      fprintf(stderr,"\n");
    }
  return 0;}	/* dummy */

/* get (x,y,z) position of site i (need for graphical output) */ 
int site_pos(int i,double pos[3]){
  /* ---  i -> (x,y)  --- */
  pos[0]=ini_pos[i][0]; 
  pos[1]=ini_pos[i][1];
  pos[2]=ini_pos[i][2];
  return 0; }

/* Wechselwirkung W=ww[i][j] zwischen site1 i und j mit J=jj[W] */

int ww_get(int i, int j){	/* nicht zeitkritisch */
  int k;
  if((i>N) || (j>N))return 0;
  for(k=0;k<ini_nw;k++){
    if(ini_iw[k][0]==i && ini_iw[k][1]==j) return ini_wj[k];
    if(ini_iw[k][0]==j && ini_iw[k][1]==i) return ini_wj[k];
  }
  return 0;	/* not found */
}

int ww_num_neighbours(int i){ /* number of neighbours of site i */
  int k,j,l; j=0;
  for(k=0;k<ini_nw;k++)for(l=0;l<2;l++)if(ini_iw[k][l]==i) j++;
  return(j);}

/* j=neighbour(site number) r=bound_type_number */
int ww_neighbour(int i,int n,int *j,int *r){ /* n-th neighbour of site i */
  int k,l;
  for(k=0;k<ini_nw;k++)for(l=0;l<2;l++)if(ini_iw[k][l]==i){
    if(n==0){ *r=ini_wj[k];*j=ini_iw[k][1-l]; return 0;}
    n--;
  }
  *j=i;*r=0;return -1;
  return 0;}

