#
# raw2fig.awk by Joerg Schulenburg
# awk-script for generating xfig-picture from mcarlo output
#
# v1.1 Nov04 - z-component as gray level, circle radius times two
# v1.0 Feb00
#
# see /usr/doc/info/gawk.info.gz
#
# XFIG 3.2: 1200dpi 
#   circle:1 3 0 width=1 pcolor=0  fcolor=7  depth=9 0 fill5%=20 0.000 1 angle=0.0000 cx=6030 cy=1170 rx=229 ry=229 x1=6030 y1=1170 x2=6259 y2=1170\n
#   line:  2 1 0 width=2 pcolor=-1 fcolor=-1 depth=0 0 -1 0.000 0 0 -1 0 0 points=2\n\t x1 y1 x2 y2\n
#   string:4 justifyLCR=0 color=-1 0 0 0 size=18 0.0000 4 dy=195 dx=n*135 x1 y1 string\001\n
#
  function outs( x, y, rz, s, c){ # number  c=color s=number
    rr=230*2                      # radius of circles
    printf "1 3 0  1 0 7 20 0 %2d 0.00 1 0.00 %d %d %d %d %d %d %d %d\n",int((rz+1)*10),x,y,rr,rr,x,y,x+rr,y;
    printf "4 1 %d 0 0 0 18 0.00000 4 195 135 %d %d %d\\001\n",c,x,y+90,s }
  function outc( x, y, s, c){ # string  c=color s=string
    printf "4 0 %d 0 0 0 18 0.00000 4 195 135 %d %d %s\\001\n",c,x+10,y+7,s }
  BEGIN { nr=0; sc=80*15;  xl=yl=zl=0; xh=yh=zh=10;
    printf "#FIG 3.2\nLandscape\nCenter\nMetric\nA4\n100.0\nSingle\n-2\n1200 2\n"
   }
  /^\#/ { printf "#%s\n", $0 }
  /^box/ {	# box x0 y0 z0  x1 y1 z1
    xl=$2-1; yl=$3-1; zl=$4-1;
    xh=$2+1; yh=$3+1; zh=$4+1;
  }
  /^line/  {	# line x0 y0 z0  x1 y1 z1  sisj
      printf "# %s\n", $0
      color=(($8>0)?1:4)  # blue>0 or red<=0
      width=1+sqrt($8*$8)*9
      s1="2 1 0 %d %d 4 40 0 -1 0.000 0 0 -1 0 0 2\n\t %d %d %d %d\n"
      printf s1, width, color, sc*($2-xl), sc*($3-yl),  sc*($5-xl), sc*($6-yl);
  }
  /^spin/  {    # spin x0 y0 z0  rx ry rz  num  theta phi
      printf "# %s\n", $0
      s1="2 1 0 5 3 3 10 0 -1 0.000 0 0 -1 1 0 2\n\t 0 0 3 240 330\n\t %d %d %d %d\n"
      printf s1, sc*($2-xl-.4*$5), sc*($3-yl-.4*$6), \
                 sc*($2-xl+.4*$5), sc*($3-yl+.4*$6);
      outs( sc*($2-xl), sc*($3-yl), $7, $8, 1 )  # 2=red 3=cyan 4=red 1=blue
  }
